# 定义角色类作为父类
class Role:
    def __init__(self, name, age):
        self.name = name
        self.age = age

    def view_course_schedule(self):
        return f"{self.name} 正在查看课表。"

# 定义学生类作为子类
class Student(Role):
    def __init__(self, name, age, class_name):
        super().__init__(name, age)  # 调用父类的构造方法
        self.class_name = class_name

    def view_course_schedule(self):
        # 重写父类的查看课表方法
        schedule = super().view_course_schedule()  # 调用父类的查看课表方法
        return f"{schedule} 学生 {self.name} 所在班级：{self.class_name}"

    def select_course(self):
        return f"学生 {self.name} 正在选课。"

# 定义老师类作为子类
class Teacher(Role):
    def __init__(self, name, age, department):
        super().__init__(name, age)  # 调用父类的构造方法
        self.department = department

    def view_course_schedule(self):
        # 重写父类的查看课表方法
        schedule = super().view_course_schedule()  # 调用父类的查看课表方法
        return f"{schedule} 老师 {self.name} 所属部门：{self.department}"

    def record_grades(self):
        return f"老师 {self.name} 正在录入成绩。"

# 测试代码
if __name__ == "__main__":
    # 创建学生实例
    student = Student(name="张三", age=20, class_name="软件工程1班")
    print(student.view_course_schedule())  # 调用查看课表方法
    print(student.select_course())  # 调用选课方法

    print("-" * 30)

    # 创建老师实例
    teacher = Teacher(name="李四", age=35, department="计算机科学与技术系")
    print(teacher.view_course_schedule())  # 调用查看课表方法
    print(teacher.record_grades())  # 调用录入成绩方法